import 'package:freezed_annotation/freezed_annotation.dart';

part 'failures.freezed.dart';

@freezed
class ValueFailure<T> with _$ValueFailure<T> {
  const factory ValueFailure.empty({
    required T failedValue,
  }) = Empty<T>;
  const factory ValueFailure.short({
    required T failedValue,
  }) = Short<T>;
  const factory ValueFailure.invalidEmail({
    required T failedValue,
  }) = InvalidEmail<T>;
  const factory ValueFailure.invalidPhone({
    required T failedValue,
  }) = InvalidPhone<T>;
  const factory ValueFailure.weakPassword({
    required T failedValue,
  }) = WeakPassword<T>;
  const factory ValueFailure.exceedingLength({
    required T failedValue,
  }) = ExceedingLength<T>;
}
